#include <stdio.h>


FILE *out;


void Cat(char *filename)
{
static char buff[1001];
static char file[1001];
FILE *in;

	fprintf(stderr, "Appending %s ...\n", filename);

	sprintf(file, "data/%s", filename);

	if ((in = fopen(file, "r")) == NULL) {
		fprintf(stderr, "Can't open file %s.\n", file);
		exit(1);
	}

	do {
		if (fgets(buff, 1000, in) > 0)
			fputs(buff, out);
	} while (!feof(in));

	fclose(in);
}



int main(void)
{
	if ((out = fopen("object.cc", "w")) == NULL) {
		fprintf(stderr, "Cannot open output\n");
		exit(1);
	}


	fprintf(out, "#include \"togl.h\"\n#include \"global.h\"\n\nvoid ObjectsInit()\n{\n\n");

#define go(what,name) fprintf(out, "glNewList(OBJ_" #what ", GL_COMPILE);\n");Cat(name);fprintf(out, "glEndList();\n");

#define go2(what,name,inst) fprintf(out, "glNewList(OBJ_" #what ", GL_COMPILE);glPushMatrix();%s\n", inst);Cat(name);fprintf(out, "glPopMatrix();\nglEndList();\n");

#define go2end(what,name,inst) fprintf(out, "glNewList(OBJ_" #what ", GL_COMPILE);%s\n", inst);Cat(name);fprintf(out, "glEndList();\n");

//============================
	go2(TORSO_MAN, "torso_man.c", "glTranslatef(0.0,0.0,0.005);");
	go2(TORSO_WOMAN, "torso_woman_small.c", "glTranslatef(0.0,0.0,0.085);");
	go(PELVIS, "pelvis.c")
	go(NECK, "neck.c")
	go(HEADFACE, "face.c")
	go(HEADHAIR, "hair.c")

//----------------------------
	go(LEFT_THIGH, "Lthigh.c");
	go2(LEFT_LEG, "Lleg.c", "glTranslatef(-0.0075,0.0,-0.0155);");
	go2(LEFT_FOOT, "Lfoot.c", "glTranslatef(-0.0105,0.0,-0.01);");
	go2end(LEFT_TOE, "Ltoe.c", "glTranslatef(-0.0182,0.0,0.034);");

	go2(LEFT_ARM, "Larm.c", "glRotatef(-5.0, 0.0, 0.0, 1.0);glTranslatef(0.01,0.0,0.0);");
	go2(LEFT_FOREARM, "Lforearm.c", "glRotatef(8.0, 1.0, 0.0, 0.0); glTranslatef(-0.01, 0.0, 0.02);");
	go2end(LEFT_HAND, "Lhand.c", "glRotatef(9.0, 1.0, 0.0, 0.0); glRotatef(15.0, 0.0, 1.0, 0.0);	glTranslatef(-0.01, 0.0, 0.02);");

//----------------------------
	go(RIGHT_THIGH, "Rthigh.c");
	go2(RIGHT_LEG, "Rleg.c", "glTranslatef(+0.0075,0.0,-0.0155);");
	go2(RIGHT_FOOT, "Rfoot.c", "glTranslatef(+0.0105,0.0,-0.01);");
	go2end(RIGHT_TOE, "Rtoe.c", "glTranslatef(+0.0182,0.0,0.034);");

	go2(RIGHT_ARM, "Rarm.c", "glRotatef(+5.0, 0.0, 0.0, 1.0);glTranslatef(-0.01,0.0,0.0);");
	go2(RIGHT_FOREARM, "Rforearm.c", "glRotatef(8.0, 1.0, 0.0, 0.0); glTranslatef(+0.01, 0.0, 0.02);");
	go2end(RIGHT_HAND, "Rhand.c", "glRotatef(9.0, 1.0, 0.0, 0.0); glRotatef(-15.0, 0.0, 1.0, 0.0);	glTranslatef(+0.01, 0.0, 0.02);");


//============================

	fprintf(out, "}\n");
	fclose(out);

	return 0;
}

