#=================================================================================================
#	Body
#=================================================================================================

#---- Set & get
body get/set <<all joints>>
body get/set name

#---- Other
body limits joint ---> {min max}
body position joint withJointOnly withNoTurn ---> {X Y Z}


#=================================================================================================
#	Routine
#=================================================================================================

#---- Set & get
routine get/set beats
routine get/set dancers
routine get/set time
routine get/set name
routine get/set description
routine get movies

routine get/set dancername indexDancer
routine get/set dancertype indexDancer
routine get/set dancersex indexDancer
routine get/set body indexDancer
routine get/set jointsusedby indexDancer

#-------------------------------------------------------------------------------------------------

#---- I/O on file
routine parse filename
routine load filename
routine save filename

#---- Get info on objects
routine keys dancer joint|notes ?start end (for joint)?
		---> list of int (<0 if partial, >=0 otherwise)
		---> list of {start end id} for notes

routine figures ?dancer joint? ---> list of filename
							   ---> list of {id start end} for joint of dancer
routine figure figureID color|filename|name|start|end|map|jointsusedby
				?value (color/notes only)? ---> value
routine figure figureID reject dancer joint

#---- Handle notes
routine note add time ?timeEnd? dancer text ---> noteID
routine note delete noteID ---> noteID deleted | -1
routine note exists time dancer ---> size | -1
routine note get noteID ---> text
routine note id time dancer ---> noteID | -1
routine note modify noteID start/-1 ?end/-1? ?text? ---> bool (success)
routine note next|prev time dancer ---> time
routine note text time dancer ---> text

#---- Change in routine & update
routine sync time dancer track
routine update cog|joints body ?constant|linear|bezier? ---> list of "joint time"

#---- Management of dancers
routine dancer add name
routine dancer delete name

#---- Management of movies
routine movie add name
routine movie delete name

#---- Management of figures & deletion
routine checkinsertion routine time {dancer1 dancer2 ...}
		---> { {list of conflict dancer 1} {list of conflict dancer 2} ... }
routine insert routine filename color includeNotes asKey time {dancer1 dancer2 ...} 
		?{{reject list dancer 1} {reject list dancer 2}}?
		---> {figureID list_of_dancerIndex_affected}

#---- Misc
routine applyto dancer time body

#---- Debug
routine dump




#=================================================================================================
#	Movie
#=================================================================================================

#---- Set & get
movie get/set time
movie get/set mode		(edit, view or play)
movie     set movie
movie get/set showheight
movie get/set showhandle
movie get/set showline
movie get/set colorEye
movie get/set colorCenter

#-------------------------------------------------------------------------------------------------

#---- Inheritance from 3D view
movie configure
movie render
movie swapbuffers
movie makecurrent

movie persp
movie ortho
movie add body ?body ...?
movie remove body ?body ...?

#---- Operation
movie pick x y ---> {path time type}
movie viewpoint
movie record movieViewpoint
movie modify {path time type} x y z			(type extended to align, delete, linearize)

#---- Get info
movie info iscontrol|preveye|nexteye|prevcenter|nextcenter time ---> bool or <x,y,z>
