#include "togl.h"

#include "view.h"
#include "track.h"
#include "routine.h"

//================================================================================================

void ViewTrack::Draw(int draw_mode, int i) const
{
class Track *t = &routine->dancers[dancer]->track[track[i]];


	if (!t->IsUsed())
		return;

	// the data (line)
	if (draw_mode == SELECT) {
		glLoadName(VT_LINE);	// type
		glPushName(0);
		for(ListIterator<Chunk> c(t->data); c; ++c) {
			if (c()->startTime <= xmax && c()->endTime >= xmin) {
				glLoadName(c()->startTime);
				glBegin(GL_LINES);
				c()->Draw();
				glEnd();
			}
		}
		glBegin(GL_LINES);
		glVertex2d(t->data->last()->endTime, t->data->last()->endValue);
		glVertex2d(1000000, t->data->last()->endValue);
		glEnd();
	} else {
		glColor3dv(color.line[i]);
		glBegin(GL_LINE_STRIP);		
		for(ListIterator<Chunk> c(t->data); c; ++c) {
			if (c()->startTime <= xmax && c()->endTime >= xmin) {
				c()->Draw();
			}
		}
		glVertex2d(t->data->last()->endTime, t->data->last()->endValue);
		glVertex2d(1000000, t->data->last()->endValue);
		glEnd();
	}

	if (drawHandles) {
		// the handles (if any)
		if (draw_mode == SELECT) {
			glPopName();
			glLoadName(VT_HANDLE);	// type
			glPushName(0);
		} else {
			glColor3dv(color.handle);
			glPointSize(pointSize);
		}
		for(ListIterator<Chunk> c(t->data); c; ++c) {
			c()->DrawHandle();
		}
	}

	// the point
	if (draw_mode == SELECT) {
		glPopName();
		glLoadName(VT_POINT);	// type
		glPushName(0);
	} else {
		glColor3dv(color.point);
		glPointSize(pointSize);
	}
	ListIterator<Chunk> c(t->data);
	glLoadName(c()->startTime);	// time
	glBegin(GL_POINTS);
	glVertex2f(c()->startTime, c()->startValue);
	glEnd();
	for(; c; ++c) {
		glLoadName(c()->endTime);	// time
		glBegin(GL_POINTS);
		glVertex2f(c()->endTime, c()->endValue);
		glEnd();
	}

	// restore the state
	if (draw_mode == SELECT) {
		glPopName();
	}
}
