#include "togl.h"
#include "view.h"

extern "C" int Tix_Init(Tcl_Interp *interp);
extern void Togl_Setup(Tcl_Interp *interp);
extern void Gepetto_Setup(Tcl_Interp *interp);


//================================================================================================
//
// Called by Tk_Main() to let me initialize the modules (Togl) I will need.
//

#ifndef WIN32

int my_init(Tcl_Interp *interp)
{
	// Initialize Tcl, Tk, Tix and the Togl widget module.
	if (Tcl_Init(interp) == TCL_ERROR) {
		return TCL_ERROR;
	}
	if (Tk_Init(interp) == TCL_ERROR) {
		return TCL_ERROR;
	}
	if (Tix_Init(interp) == TCL_ERROR) {
		return TCL_ERROR;
	}
	if (Togl_Init(interp) == TCL_ERROR) {
		return TCL_ERROR;
	}

	Togl_Setup(interp);
	Gepetto_Setup(interp);

	// create the commands
    Tcl_CreateCommand(interp, "body", BodyCreate_Cmd,
                      (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
    Tcl_CreateCommand(interp, "light", LightCreate_Cmd,
                      (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
    Tcl_CreateCommand(interp, "routine", RoutineCreate_Cmd,
                      (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);

    Tcl_CreateObjCommand(interp, "check", Check_ObjCmd,
                      (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);

	// init some vars
	Tcl_EvalFile(interp, "./main.tcl");

	Tcl_Eval(interp, "bind all <Control-c> exit");
	Tcl_SetVar(interp, "tcl_rcFileName", "./autorun.tcl", TCL_GLOBAL_ONLY);

	return TCL_OK;
}

int main(int argc, char *argv[])
{
	Tk_Main(argc, argv, my_init);
	return 0;
}

#else

extern "C" void my_init(Tcl_Interp *interp)
{
	Togl_Setup(interp);
	Gepetto_Setup(interp);


    Tcl_CreateCommand(interp, "body", BodyCreate_Cmd,
                      (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
    Tcl_CreateCommand(interp, "light", LightCreate_Cmd,
                      (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);
    Tcl_CreateCommand(interp, "routine", RoutineCreate_Cmd,
                      (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);

    Tcl_CreateObjCommand(interp, "check", Check_ObjCmd,
                      (ClientData) NULL, (Tcl_CmdDeleteProc *) NULL);


	Tcl_EvalFile(interp, "./main.tcl");

	Tcl_Eval(interp, "bind all <Control-c> exit");
	Tcl_SetVar(interp, "tcl_rcFileName", "./autorun.tcl", TCL_GLOBAL_ONLY);
}

#endif
