#-- preferences for windows position
set status(pref:routine:pos) +0+100
set status(pref:routine:size) 442x410

set status(pref:stage:pos) +450+0
set status(pref:stage:size) 566x509

set status(pref:movie:pos) +0+100
set status(pref:movie:size) 930x540

set status(pref:library:pos) +450+534
set status(pref:library:size) 566x197

set status(pref:main:pos) +0+0
set status(pref:main:size) 442x46

#-- some settings --------------------------------------------------------------------------------
set status(v:tip:show) 1
set status(v:tip:delay) 700
set status(v:tip:delayLong) 1500


#-- define the fonts -----------------------------------------------------------------------------
if {$tcl_platform(platform) == "windows"} {
	# Windows fonts
	font create "checklist"					-family Arial -size 10 
	font create "entry"						-family Arial -size 10 
	font create "entry:small"				-family Arial -size 8 
	font create "menubutton"				-family Arial -size 10 
	font create "menubutton:small"			-family Arial -size 8 
	font create "notebook"					-family Arial -size 10 -weight bold
	font create "popupmenu"					-family Arial -size 10 
	font create "status"					-family Arial -size 8 
	font create "tip"						-family Arial -size 8 

	font create "body:header"				-family Arial -size 10 -weight bold
	font create "body:text"					-family Arial -size 10
	font create "library:class"				-family Arial -size 10 
	font create "library:routine:header"	-family Arial -size 8 -weight bold
	font create "library:routine:text"		-family Arial -size 8 
	font create "library:status"			-family Arial -size 8 
	font create "movie:notes"				-family Arial -size 8 
	font create "routine:bpm"				-family Arial -size 10 
	font create "routine:list"				-family Arial -size 10 
	font create "routine:list:bold"			-family Arial -size 10 -weight bold
	font create "routine:map"				-family Arial -size 10 
	font create "routine:time"				-family Arial -size 10
	font create "stage"						-family Arial -size 10
	font create "viewtrack"					-family Arial -size 8 

} else {
	# X fonts
# 	font create "checklist"					-family Helvetica -size 14 
# 	font create "entry"						-family Helvetica -size 14 
# 	font create "entry:small"				-family Helvetica -size 10 
# 	font create "menubutton"				-family Helvetica -size 12 
# 	font create "menubutton:small"			-family Helvetica -size 10 
# 	font create "notebook"					-family Helvetica -size 14 -weight bold
# 	font create "popupmenu"					-family Helvetica -size 12 
# 	font create "status"					-family Helvetica -size 10 
# 	font create "tip"						-family Helvetica -size 10 

# 	font create "body:header"				-family Helvetica -size 14 -weight bold
# 	font create "body:text"					-family Helvetica -size 14
# 	font create "library:class"				-family Helvetica -size 14 
# 	font create "library:routine:header"	-family Helvetica -size 12 -weight bold
# 	font create "library:routine:text"		-family Helvetica -size 12 
# 	font create "library:status"			-family Helvetica -size 12 
# 	font create "movie:notes"				-family Helvetica -size 12 
# 	font create "routine:list"				-family Helvetica -size 14 
# 	font create "routine:list:bold"			-family Helvetica -size 14 -weight bold
# 	font create "routine:map"				-family Helvetica -size 14
# 	font create "routine:time"				-family Helvetica -size 12
# 	font create "stage"						-family Helvetica -size 12
# 	font create "viewtrack"					-family Helvetica -size 10

	# X fonts
	font create "checklist"					-family Helvetica -size 12 
	font create "entry"						-family Helvetica -size 12
	font create "entry:small"				-family Helvetica -size 8 
	font create "menubutton"				-family Helvetica -size 10 
	font create "menubutton:small"			-family Helvetica -size 8 
	font create "notebook"					-family Helvetica -size 12 -weight bold
	font create "popupmenu"					-family Helvetica -size 10 
	font create "status"					-family Helvetica -size 8 
	font create "tip"						-family Helvetica -size 8 

	font create "body:header"				-family Helvetica -size 12 -weight bold
	font create "body:text"					-family Helvetica -size 12
	font create "library:class"				-family Helvetica -size 12 
	font create "library:routine:header"	-family Helvetica -size 10 -weight bold
	font create "library:routine:text"		-family Helvetica -size 10 
	font create "library:status"			-family Helvetica -size 10 
	font create "movie:notes"				-family Helvetica -size 10 
	font create "routine:list"				-family Helvetica -size 10 
	font create "routine:list:bold"			-family Helvetica -size 10 -weight bold
	font create "routine:map"				-family Helvetica -size 12
	font create "routine:time"				-family Helvetica -size 10
	font create "stage"						-family Helvetica -size 10
	font create "viewtrack"					-family Helvetica -size 8
}


#=================================================================================================
#	END OF PREFERENCES
#=================================================================================================

set status(dir:library) "[file dirname [file dirname [info nameofexecutable]]]/library"
set status(dir:routine) "[file dirname [file dirname [info nameofexecutable]]]/routine"
set status(dir:logo.gif) "[file dirname [file dirname [info nameofexecutable]]]/doc/logo.gif"

# setup
set status(opengl) [togl .__opengl__ -width 1 -height 1 -ident "__opengl__" \
		-double true -depth true]

if {$tcl_platform(platform) == "windows"} {
	option add *Button.highlightColor lightgray widgetDefault
}

# init the memo
set memo(width) 70
set memo(height) 75
foreach i {0 1 2} {
	set filename $status(dir:library)/memo.private.$i
	if {[file exists $filename]} {
		# load image
		set memo($i:image) [image create photo -file $filename \
									-width $memo(width) -height $memo(height)]
		# load data
		set in [open $filename "r"]
		set memo($i:data) [string range [gets $in] 1 end]
		close $in
	} else {
		# new image
		set memo($i:image) [image create photo -width $memo(width) -height $memo(height)]
		$memo($i:image) put -to 0 0 100 100 {{black}}
		# reset data
		set memo($i:data) {}
	}
}

# read images
image create pixmap imgOk -file pixmap/but_ok.xpm
image create pixmap imgCancel -file pixmap/but_cancel.xpm

# register one light
light "Main light"

# load some helper functions
source checklist.tcl
source drag_drop.tcl
source toolbar.tcl
source common.tcl

# load the module
source view3D.tcl
source figure_editor.tcl
source body.tcl
source stage.tcl
source library.tcl
source library_dialog.tcl
source library_routine.tcl
source viewTrack.tcl
source player.tcl
source movie.tcl
source routine.tcl
source routine_editor.tcl
source routine_insert.tcl
source routine_notes.tcl
source routine_utils.tcl

source control_center.tcl

# go
library::init $status(pref:library:pos) $status(pref:library:size)

wm geometry . $status(pref:main:size)$status(pref:main:pos)


# handling of error
proc bgerror err {
	tk_messageBox -icon "error" -title "Error" \
			-message "Internal error.\nPlease do a bug report." -type ok
}

proc notImplemented {} {
	tk_messageBox -icon "info" -title "Error" \
			-message "Not implemented yet ..." -type ok
}
