CLASS 		View3D

GLOBAL		#include <math.h>


CODE_SET	Togl_PostRedisplay(togl);

#-------------------------------------------------------------------------------------------------
# name				type		var associated			set code (%!=entry idx, %$ = var name)

azimut				double		viewpoint.azimut
elevation			double		viewpoint.elevation
twist				double		viewpoint.twist
xtrans				double		viewpoint.xTrans
ytrans				double		viewpoint.yTrans
zoom				double		viewpoint.dist			if (%$ < 0.0) \
															%$ = 0.000001;
xpos				double		viewpoint.xPos
ypos				double		viewpoint.yPos
zpos				double		viewpoint.zPos
fovy				double		viewpoint.fovy
znear				double		viewpoint.zNear
zfar				double		viewpoint.zFar

floor:nbX			int			floor.nbX
floor:nbZ			int			floor.nbZ
floor:padX			double		floor.padX
floor:padZ			double		floor.padZ
floor:color			color		floor.color
floor:axecolor		color		floor.colorAxe

forcewire			bool		forceWire
jointsonly			bool		jointsOnly
withRX				bool		withRX
withRY				bool		withRY
withRZ				bool		withRZ
floor				bool		drawFloor
axis				bool		drawAxis
bodies				user		-
lights				user		-

sphere				bool		sphere
sphereX				bool		sphereX
sphereZ				bool		sphereZ
disk				bool		disk
size				double		size

localaxis			bool		drawLocalAxis
localaxis:X			double		localAxis.X
localaxis:Y			double		localAxis.Y
localaxis:Z			double		localAxis.Z
localaxis:pad		double		localAxis.pad
localaxis:color1	color		localAxis.color1
localaxis:color2	color		localAxis.color2

eye					user		-


#------------------------------------------------------------------------------------------------
#	 name		vars in list

LIST view			azimut elevation twist zoom xtrans ytrans
LIST pos			xpos ypos zpos
LIST camera			fovy znear zfar
LIST floor:all		floor:nbX floor:nbZ floor:padX floor:padZ floor:color

LIST all			view pos camera floor:all forcewire jointsonly floor axis

LIST movie			azimut elevation twist zoom xpos ypos zpos

LIST spheres		sphere sphereX sphereZ
LIST localaxis:pos	localaxis:X localaxis:Y localaxis:Z

LIST filters		jointsonly withRX withRY withRZ

#================================================================================================

USER_SET bodies		Tcl_SetResult(interp, "can't set bodies", TCL_STATIC);\
					return TCL_ERROR;
USER_GET bodies		{__list[0] = Tcl_NewListObj(0, NULL);\
					for (ListIterator<Body> b(bodies); b; ++b) { \
					char bodyName[10]; \
						sprintf(bodyName, "body%d", b()->number); \
				        Tcl_ListObjAppendElement(interp, __list[0], \
												 Tcl_NewStringObj(bodyName, -1)); \
					} \
        			__res = __list[0];}

#-------------------------------------------------------------------------------------------------

USER_SET lights		Tcl_SetResult(interp, "can't set lights", TCL_STATIC);\
					return TCL_ERROR;
USER_GET lights		{__list[0] = Tcl_NewListObj(0, NULL);\
					for (ListIterator<Light> l(lights); l; ++l) { \
					char lightName[10]; \
						sprintf(lightName, "light%d", l()->number); \
				        Tcl_ListObjAppendElement(interp, __list[0], \
												 Tcl_NewStringObj(lightName, -1)); \
					} \
			        __res = __list[0];}

#-------------------------------------------------------------------------------------------------

USER_SET eye		{double dx,dy,dz, xeye,yeye,zeye; \
					Tcl_ListObjGetElements(interp, objv[3], &__nb, &__list[0]); \
					if (__nb<3) {\
						Tcl_WrongNumArgs(interp, 1, &objv[2], "{xeye yeye zeye}"); \
					    return TCL_ERROR; \
					} \
					Tcl_GetDoubleFromObj(interp, __list[0][0], &xeye); \
					Tcl_GetDoubleFromObj(interp, __list[0][1], &yeye); \
					Tcl_GetDoubleFromObj(interp, __list[0][2], &zeye); \
					dx = xeye - viewpoint.xPos; \
					dy = yeye - viewpoint.yPos; \
					dz = zeye - viewpoint.zPos; \
					viewpoint.dist = sqrt(dx*dx+dy*dy+dz*dz); \
					viewpoint.elevation = 180.0/3.141592654* \
							atan2(dy, sqrt(dx*dx+dz*dz)+0.00000001); \
					viewpoint.azimut = fabs(dz)>0.00000001 ? -180.0/3.141592654*atan2(dx, dz) : \
							dx < 0 ? 90.0 : -90.0; \
					}

USER_GET eye		{double az, el; \
					az = viewpoint.azimut*3.141592654/180.0; \
					el = viewpoint.elevation*3.141592654/180.0; \
					__list[0] = Tcl_NewListObj(0, NULL); \
					Tcl_ListObjAppendElement(interp, __list[0], \
						Tcl_NewDoubleObj(viewpoint.xPos - sin(az)*cos(el)*viewpoint.dist)); \
					Tcl_ListObjAppendElement(interp, __list[0], \
						Tcl_NewDoubleObj(viewpoint.yPos +         sin(el)*viewpoint.dist)); \
					Tcl_ListObjAppendElement(interp, __list[0], \
						Tcl_NewDoubleObj(viewpoint.zPos + cos(az)*cos(el)*viewpoint.dist)); \
			        __res = __list[0];}
