CLASS 		ViewTrack

CODE_SET	Togl_PostRedisplay(togl);


#-------------------------------------------------------------------------------------------------
# name			type		var associated			set code (%!=entry idx, %$ = var name)

showtime		bool		drawCurrentTime
time			int			currentTime
maxtime			int			maxTime
maxy			int			maxY
xpos			double		xPos
ypos			double		yPos
xzoom			double		xZoom					if (%$ < 1.0) %$ = 1.0;
yzoom			double		yZoom					if (%$ < 1.0) %$ = 1.0;

showroutines	bool		drawRoutines
showhandles		bool		drawHandles

showgrid		bool		drawGrid
padtime:1		int			padTime
pady:1			int			padY
stippletime:1	int			stippleTime
stippley:1		int			stippleY
padtime:2		int			padTime2
pady:2			int			padY2
stippletime:2	int			stippleTime2
stippley:2		int			stippleY2

colorZoomBox	color		color.zoomBox
stippleZoomBox	int			stippleZoomBox

pointsize		double		pointSize

dancer			user		-
track			user		-

colorBg			color		color.bg
colorGrid		color		color.grid
colorLimits		color		color.limits
colorPoint		color		color.point
colorHandle		color		color.handle
colorSelected	color		color.selected
colorTime		color		color.time
colorLine		user		-


#------------------------------------------------------------------------------------------------
#	 name		vars in list

LIST padtime	padtime:2 padtime:1
LIST pady		pady:2 pady:1

LIST view		maxtime maxy xpos ypos xzoom yzoom padtime pady

#================================================================================================

USER_GET dancer		sprintf(__string, "routine%d %d", routine->number, dancer); \
					__res = Tcl_NewStringObj(__string, -1);

USER_SET dancer		{int n=0; struct Tcl_CmdInfo info; \
					if (objc<5) { \
						Tcl_WrongNumArgs(interp, 3, objv, "routine dancer");return TCL_ERROR; \
					} \
					__str = Tcl_GetStringFromObj(objv[3], NULL); \
					if (Tcl_GetCommandInfo(interp, __str, &info) == 0 || *__str != 'r') { \
						Tcl_AppendResult(interp,"no routine named \"",__str,"\"",(char *) NULL); \
						return TCL_ERROR; \
					} \
					Tcl_GetIntFromObj(NULL, objv[4], &n); \
					routine = (class Routine *) info.objClientData; \
					dancer = n; }

#-------------------------------------------------------------------------------------------------

USER_GET track		{int i=0; \
					if (objc<4) {Tcl_WrongNumArgs(interp, 3, objv, "index");return TCL_ERROR;} \
					Tcl_GetIntFromObj(NULL, objv[3], &i); \
					if (i<0 || i>MAX_VIEWTRACK-1) { \
						Tcl_AppendResult(interp,"bad index", (char *) NULL); \
						return TCL_ERROR; \
					} \
					if (track[i] == -1) { \
						sprintf(__string, "nil"); \
					} else { \
						sprintf(__string, trackName[track[i]]); \
					} \
					__res = Tcl_NewStringObj(__string, -1); }

USER_SET track		{int i=0, j=0; \
					if (objc<5) { \
						Tcl_WrongNumArgs(interp, 3, objv, "index body"); \
						return TCL_ERROR; \
					} \
					Tcl_GetIntFromObj(NULL, objv[3], &i); \
					if (i<0 || i>MAX_VIEWTRACK-1) { \
						Tcl_AppendResult(interp,"bad index", (char *) NULL); \
						return TCL_ERROR; \
					} \
					if (Tcl_GetIndexFromObj(interp,objv[4],trackName,"track",0,&j) != TCL_OK) { \
						return TCL_ERROR; \
					} \
					track[i] = (j >= NB_DOF ? -1 : j); }

#-------------------------------------------------------------------------------------------------

USER_GET colorLine	{int i=0; \
					if (objc<4) {Tcl_WrongNumArgs(interp, 3, objv, "index");return TCL_ERROR;} \
					Tcl_GetIntFromObj(NULL, objv[3], &i); \
					if (i<0 || i>MAX_VIEWTRACK-1) { \
						Tcl_AppendResult(interp,"bad index", (char *) NULL); \
						return TCL_ERROR; \
					} \
					sprintf(__string, "#%04X%04X%04X", (int) (color.line[i][0] * 65535.0), \
							(int) (color.line[i][1] * 65535.0), \
							(int) (color.line[i][1] * 65535.0)); \
					__res = Tcl_NewStringObj(__string, -1); }

USER_SET colorLine	{int i=0; \
					if (objc<5) { \
						Tcl_WrongNumArgs(interp, 3, objv, "index color"); \
						return TCL_ERROR; \
					} \
					Tcl_GetIntFromObj(NULL, objv[3], &i); \
					if (i<0 || i>MAX_VIEWTRACK-1) { \
						Tcl_AppendResult(interp,"bad index", (char *) NULL); \
						return TCL_ERROR; \
					} \
					if (XParseColor(Tk_Display(Tk_MainWindow(interp)), \
									Tk_Colormap(Tk_MainWindow(interp)), \
									Tcl_GetStringFromObj(objv[4], NULL), &__color) == 0) { \
						Tcl_SetResult(interp, "conversion from color \"", TCL_STATIC); \
						Tcl_AppendResult(interp, Tcl_GetStringFromObj(objv[4], NULL), \
								"\" can't be done", NULL); \
			        } else { \
						color.line[i][0] = (double) __color.red / 65536.0; \
						color.line[i][1] = (double) __color.green / 65536.0; \
						color.line[i][2] = (double) __color.blue / 65536.0; \
						color.line[i][3] = 0.0; \
					} }